/*
;    iContBBox[]        = fillarray( 12, 128, 121, 172)
;    iOscModSwBBox[]    = fillarray(125, 143,  35,  18)
;    iOsc3SwBBox[]      = fillarray(151, 303,  19,  36)
;    iOscBBox[]         = fillarray(182,  35, 196, 325)
;    iMixBBox[]         = fillarray(401,  48, 161, 314)
;    iNoiseBBox[]       = fillarray(565, 296,  18,  40)
;    iFiltModSwBBox[]   = fillarray(581,  77,  38,  20)
;    iKeyCont1SwBBox[]  = fillarray(583, 166,  36,  20)
;    iKeyCont1SwBBox8[] = fillarray(582, 216,  35,  21)
;    iFilterBBox[]      = fillarray(634,  63, 184, 172)
;    iAmpBBox[]         = fillarray(631, 290, 191,  64)
;    iVolumeBBox11[]    = fillarray(842,  63,  54,  64)
    
;    iContBBox[]        = fillarray(  8, 124, 122, 178)
;    iOscModSwBBox[]    = fillarray(125, 143,  35,  18)
;    iOsc3SwBBox[]      = fillarray(151, 303,  19,  36)
;    
;    iOscBBox[]         = fillarray(176,  35, 212, 335)
;    iMixBBox[]         = fillarray(398,  64, 164, 284)
;    iNoiseBBox[]       = fillarray(565, 296,  18,  40)
;    iFiltModSwBBox[]   = fillarray(581,  77,  38,  20)
;    iKeyCont1SwBBox[]  = fillarray(583, 166,  36,  20)
;    iKeyCont1SwBBox8[] = fillarray(582, 216,  35,  21)
;    
;    iFilterBBox[]      = fillarray(632,  65, 190, 168)
;    iAmpBBox[]         = fillarray(632, 292, 191,  64)
;    iVolumeBBox11[]    = fillarray(842,  63,  54,  64)

*/
<Cabbage>
form caption("Untitled") size(998, 401), guiMode("queue"), pluginId("def1")
image bounds(0, 0, 998, 401) file("MiniMoogPanel2.png")
</Cabbage>
<CsoundSynthesizer>
<CsOptions>
-n -d -+rtmidi=NULL -M0 -m0d --midi-key-cps=4 --midi-velocity-amp=5
</CsOptions>
<CsInstruments>
; Initialize the global variables. 
ksmps = 32
nchnls = 2
0dbfs = 1

#include "creator.csdx"
#include "bbox.csdx"

;instrument will be triggered by keyboard widget
instr 1
kEnv madsr .1, .2, .6, .4
aOut vco2 p5, p4
outs aOut*kEnv, aOut*kEnv
endin

opcode addLabeledKnob, 0, i[]SS
    iBBox[], SLabel, SChan xin
    
    x_create "rslider", fillarray(x_bounds(iBBox), x_channel(SChan))
    x_create "label", fillarray(x_bounds(bb_inset(bb_outside(iBBox, 80, 20, "ct"), 2, 2)), x_text(SLabel))
endop

;- Region: opcode makeControls
opcode makeControls, 0, i[]i
    iBBox[], iKnobSize xin
    
    iTuneBBox[]   = bb_inside(iBBox, iKnobSize, iKnobSize, "ct")
    iGlideBBox[]  = bb_inside(iBBox, iKnobSize, iKnobSize, "lb")
    iModMixBBox[] = bb_inside(iBBox, iKnobSize, iKnobSize, "rb")
    
    cabbageCreate "image", sprintf("bounds(%d, %d, %d, %d) colour(40, 40, 40, 75)", iBBox[0], iBBox[1], iBBox[2], iBBox[3])
;    x_create "image", fillarray(x_bounds(iBBox), x_colour(40, 40, 40, 75))
;    x_create "image", fillarray(x_bounds(iTuneBBox), x_colour(20, 120, 20, 75))
;    x_create "image", fillarray(x_bounds(iGlideBBox), x_colour(20, 120, 20, 75))
;    x_create "image", fillarray(x_bounds(iModMixBBox), x_colour(20, 120, 20, 75))
    
;    addLabeledKnob(iTuneBBox, "Tune", "tune")
;    addLabeledKnob(iGlideBBox, "Glide", "glide")
;    addLabeledKnob(iModMixBBox, "ModMix", "modmix")
endop

;- Region: opcode makeOscillators
opcode makeOscillators, 0, i[]i
    iBBox[], iKnobSize xin
    
    iBBoxes[][] bb_split iBBox, 3, 3, "lrtb"
    
    iOsc1RangeBBox[] = bb_inside(getrow(iBBoxes, 0), iKnobSize, iKnobSize, "cm")
    iOsc1WaveBBox[]  = bb_inside(getrow(iBBoxes, 2), iKnobSize, iKnobSize, "cm")
    iOsc2RangeBBox[] = bb_inside(getrow(iBBoxes, 3), iKnobSize, iKnobSize, "cm")
    iOsc2TuneBBox[]  = bb_inside(getrow(iBBoxes, 4), iKnobSize, iKnobSize, "cm")
    iOsc2WaveBBox[]  = bb_inside(getrow(iBBoxes, 5), iKnobSize, iKnobSize, "cm")
    iOsc3RangeBBox[] = bb_inside(getrow(iBBoxes, 6), iKnobSize, iKnobSize, "cm")
    iOsc3TuneBBox[]  = bb_inside(getrow(iBBoxes, 7), iKnobSize, iKnobSize, "cm")
    iOsc3WaveBBox[]  = bb_inside(getrow(iBBoxes, 8), iKnobSize, iKnobSize, "cm")
    
    x_create "image", fillarray(x_bounds(iBBox), x_colour(40, 40, 40, 75))
    x_create "image", fillarray(x_bounds(iOsc1RangeBBox), x_colour(20, 120, 20, 75))
    x_create "image", fillarray(x_bounds(iOsc1WaveBBox), x_colour(20, 120, 20, 75))
    x_create "image", fillarray(x_bounds(iOsc2RangeBBox), x_colour(20, 120, 20, 75))
    x_create "image", fillarray(x_bounds(iOsc2TuneBBox), x_colour(20, 120, 20, 75))
    x_create "image", fillarray(x_bounds(iOsc2WaveBBox), x_colour(20, 120, 20, 75))
    x_create "image", fillarray(x_bounds(iOsc3RangeBBox), x_colour(20, 120, 20, 75))
    x_create "image", fillarray(x_bounds(iOsc3TuneBBox), x_colour(20, 120, 20, 75))
    x_create "image", fillarray(x_bounds(iOsc3WaveBBox), x_colour(20, 120, 20, 75))

;    addLabeledKnob(iOsc1RangeBBox, "Range", "osc1range")
;    addLabeledKnob(iOsc1WaveBBox, "Waveform", "osc1wave")
;    addLabeledKnob(iOsc2RangeBBox, "Range", "osc2range")
;    addLabeledKnob(iOsc2TuneBBox, "", "osc2tuning")
;    addLabeledKnob(iOsc2WaveBBox, "Waveform", "osc2wave")
;    addLabeledKnob(iOsc3RangeBBox, "Range", "osc3range")
;    addLabeledKnob(iOsc3TuneBBox, "", "osc3tuning")
;    addLabeledKnob(iOsc3WaveBBox, "Waveform", "osc3wave")
endop

;- Region: opcode makeMixer
opcode makeMixer, 0, i[]i
    iBBox[], iKnobSize xin
    
    iBBoxes[][] bb_split iBBox, 3, 5, "tblr"
    printarray iBBoxes, "%d", "iBBoxes makeMixer"
    
    iOsc1VolBBox[]   = bb_inside(getrow(iBBoxes, 0), iKnobSize, iKnobSize, "cm")
    iOsc2VolBBox[]   = bb_inside(getrow(iBBoxes, 2), iKnobSize, iKnobSize, "cm")
    iOsc3VolBBox[]   = bb_inside(getrow(iBBoxes, 4), iKnobSize, iKnobSize, "cm")
    
    iOsc1OnSwBBox[]  = bb_inside(getrow(iBBoxes, 5), 36, 18, "cm")
    iExtOnSwBBox[]   = bb_inside(getrow(iBBoxes, 6), 36, 18, "cm")
    iOsc2OnSwBBox[]  = bb_inside(getrow(iBBoxes, 7), 36, 18, "cm")
    iNoiseOnSwBBox[] = bb_inside(getrow(iBBoxes, 8), 36, 18, "cm")
    iOsc3OnSwBBox[]  = bb_inside(getrow(iBBoxes, 9), 36, 18, "cm")
    
    iExtVolBBox[]    = bb_inside(getrow(iBBoxes, 11), iKnobSize, iKnobSize, "cm")
    iNoiseVolBBox[]  = bb_inside(getrow(iBBoxes, 13), iKnobSize, iKnobSize, "cm")
    
    x_create "image", fillarray(x_bounds(iBBox), x_colour(40, 40, 40, 75))
    x_create "image", fillarray(x_bounds(iOsc1VolBBox), x_colour(20, 120, 20, 75))
    x_create "image", fillarray(x_bounds(iOsc2VolBBox), x_colour(20, 120, 20, 75))
    x_create "image", fillarray(x_bounds(iOsc3VolBBox), x_colour(20, 120, 20, 75))
    
    x_create "image", fillarray(x_bounds(iOsc1OnSwBBox), x_colour(20, 120, 20, 75))
    x_create "image", fillarray(x_bounds(iExtOnSwBBox), x_colour(20, 120, 20, 75))
    x_create "image", fillarray(x_bounds(iOsc2OnSwBBox), x_colour(20, 120, 20, 75))
    x_create "image", fillarray(x_bounds(iNoiseOnSwBBox), x_colour(20, 120, 20, 75))
    x_create "image", fillarray(x_bounds(iOsc3OnSwBBox), x_colour(20, 120, 20, 75))
    
    x_create "image", fillarray(x_bounds(iExtVolBBox), x_colour(20, 120, 20, 75))
    x_create "image", fillarray(x_bounds(iNoiseVolBBox), x_colour(20, 120, 20, 75))
endop

;- Region: opcode makeFilter
opcode makeFilter, 0, i[]i
    iBBox[], iKnobSize xin
    
    iBBoxes[][] bb_split iBBox, 3, 2, "lrtb"
    
    x_create "image", fillarray(x_bounds(iBBox), x_colour(40, 40, 40, 75))
    x_create "image", fillarray(x_bounds(bb_inside(getrow(iBBoxes, 0), 50, 50, "lt")), x_colour(20, 120, 20, 75))
    x_create "image", fillarray(x_bounds(bb_inside(getrow(iBBoxes, 1), 50, 50, "ct")), x_colour(20, 120, 20, 75))
    x_create "image", fillarray(x_bounds(bb_inside(getrow(iBBoxes, 2), 50, 50, "rt")), x_colour(20, 120, 20, 75))
    x_create "image", fillarray(x_bounds(bb_inside(getrow(iBBoxes, 3), 50, 50, "lb")), x_colour(20, 120, 20, 75))
    x_create "image", fillarray(x_bounds(bb_inside(getrow(iBBoxes, 4), 50, 50, "cb")), x_colour(20, 120, 20, 75))
    x_create "image", fillarray(x_bounds(bb_inside(getrow(iBBoxes, 5), 50, 50, "rb")), x_colour(20, 120, 20, 75))
endop

;- Region: opcode makeAmp
opcode makeAmp, 0, i[]i
    iBBox[], iKnobSize xin
    
    iBBoxes[][] bb_split iBBox, 3, "v"
    
    x_create "image", fillarray(x_bounds(iBBox), x_colour(40, 40, 40, 75))
    x_create "image", fillarray(x_bounds(bb_inside(getrow(iBBoxes, 0), 50, 50, "lt")), x_colour(20, 120, 20, 75))
    x_create "image", fillarray(x_bounds(bb_inside(getrow(iBBoxes, 1), 50, 50, "ct")), x_colour(20, 120, 20, 75))
    x_create "image", fillarray(x_bounds(bb_inside(getrow(iBBoxes, 2), 50, 50, "rt")), x_colour(20, 120, 20, 75))
endop

instr builder
    iContBBox[]        = fillarray( 12, 128, 121, 172)
    iOscBBox[]         = fillarray(182,  35, 196, 325)
    iMixBBox[]         = fillarray(401,  48, 161, 314)
    iFilterBBox[]      = fillarray(634,  63, 184, 172)
    iAmpBBox[]         = fillarray(631, 290, 191,  64)
    
;    iContBBox[]        = fillarray(  8, 124, 122, 178)
;    iOscBBox[]         = fillarray(176,  35, 212, 335)
;    iMixBBox[]         = fillarray(398,  64, 164, 284)
;    iFilterBBox[]      = fillarray(632,  65, 190, 168)
;    iAmpBBox[]         = fillarray(632, 292, 191,  64)

    iKnobSize = 56
    
    makeControls(iContBBox, iKnobSize)
    makeOscillators(iOscBBox, iKnobSize * 1.25)
    makeMixer(iMixBBox, iKnobSize)
    makeFilter(iFilterBBox, iKnobSize)
    makeAmp(iAmpBBox, iKnobSize)
endin

</CsInstruments>
<CsScore>
;causes Csound to run for about 7000 years...

i "builder" 0 0
f0 z
</CsScore>
</CsoundSynthesizer>
